/*
 * KeySetsContainer.hpp
 *
 *  Created on: Sep 15, 2011
 *      Author: heber
 */

#ifndef KEYSETSCONTAINER_HPP_
#define KEYSETSCONTAINER_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


/** Contains the index set for each fragment.
 *
 */
class KeySetsContainer {
  public:
    typedef std::vector<int> IntVector;
    typedef std::vector<IntVector> ArrayOfIntVectors;
    ArrayOfIntVectors KeySets;
    IntVector AtomCounter;
    int FragmentCounter;
    int Order;
    IntVector FragmentsPerOrder;
    ArrayOfIntVectors OrderSet;

  KeySetsContainer();
  ~KeySetsContainer();

  bool ParseKeySets(const std::string name, const std::vector<int> ACounter, const int FCounter);
  bool ParseManyBodyTerms();
  bool Contains(const int GreaterSet, const int SmallerSet);
};


#endif /* KEYSETSCONTAINER_HPP_ */
